# 搭建环境<a name="ZH-CN_TOPIC_0000001054022306"></a>

-   [前提条件](#section2074878255)
-   [Hi3518环境特有要求](#section1724111409282)
    -   [硬件要求](#section487353718276)
    -   [软件要求](#section17315193935817)

-   [安装Linux编译环境](#section8831868501)
    -   [安装文件打包工具](#section480195453419)
    -   [安装hc-gen](#section351420104218)


## 前提条件<a name="section2074878255"></a>

Hi3518环境搭建前，请先完成[搭建系统基础环境](搭建系统基础环境.md)。

## Hi3518环境特有要求<a name="section1724111409282"></a>

### 硬件要求<a name="section487353718276"></a>

-   Hi3518EV300 IoT Camera开发板
-   USB转串口线、网线（Windows工作台通过USB转串口线、网线与开发板连接）

    各硬件连接关系如下图所示。


**图 1**  硬件连线图<a name="fig8211468392"></a>  
![](figures/硬件连线图.png "硬件连线图")

### 软件要求<a name="section17315193935817"></a>

>![](public_sys-resources/icon-notice.gif) **须知：** 
>本节描述安装包方式搭建编译环境的操作步骤。如果是Docker方式安装编译环境，请跳过此章节以及下述安装Linux编译环境章节。

Hi3518开发板对Linux服务器通用环境配置需要的工具及其获取途径如下表所示。

**表 1**  Linux服务器开发工具及获取途径

<a name="table15485545145811"></a>
<table><thead align="left"><tr id="row1748610451588"><th class="cellrowborder" valign="top" width="23.332333233323332%" id="mcps1.2.4.1.1"><p id="p13486154545816"><a name="p13486154545816"></a><a name="p13486154545816"></a>开发工具</p>
</th>
<th class="cellrowborder" valign="top" width="14.65146514651465%" id="mcps1.2.4.1.2"><p id="p44867452589"><a name="p44867452589"></a><a name="p44867452589"></a>用途</p>
</th>
<th class="cellrowborder" valign="top" width="62.016201620162015%" id="mcps1.2.4.1.3"><p id="p1748619458583"><a name="p1748619458583"></a><a name="p1748619458583"></a>获取途径</p>
</th>
</tr>
</thead>
<tbody><tr id="row08231641105420"><td class="cellrowborder" valign="top" width="23.332333233323332%" headers="mcps1.2.4.1.1 "><p id="p1682494111548"><a name="p1682494111548"></a><a name="p1682494111548"></a>dosfstools、mtools、mtd-utils</p>
</td>
<td class="cellrowborder" valign="top" width="14.65146514651465%" headers="mcps1.2.4.1.2 "><p id="p1362445934918"><a name="p1362445934918"></a><a name="p1362445934918"></a>文件打包工具</p>
</td>
<td class="cellrowborder" valign="top" width="62.016201620162015%" headers="mcps1.2.4.1.3 "><p id="p1262475944916"><a name="p1262475944916"></a><a name="p1262475944916"></a>通过apt-get install安装</p>
</td>
</tr>
<tr id="row1548710453586"><td class="cellrowborder" valign="top" width="23.332333233323332%" headers="mcps1.2.4.1.1 "><p id="p15487114585814"><a name="p15487114585814"></a><a name="p15487114585814"></a>hc-gen</p>
</td>
<td class="cellrowborder" valign="top" width="14.65146514651465%" headers="mcps1.2.4.1.2 "><p id="p148719452588"><a name="p148719452588"></a><a name="p148719452588"></a>驱动配置编译工具</p>
</td>
<td class="cellrowborder" valign="top" width="62.016201620162015%" headers="mcps1.2.4.1.3 "><p id="p1487164565819"><a name="p1487164565819"></a><a name="p1487164565819"></a><a href="https://repo.huaweicloud.com/harmonyos/compiler/hc-gen/0.65/linux/hc-gen-0.65-linux.tar" target="_blank" rel="noopener noreferrer">https://repo.huaweicloud.com/harmonyos/compiler/hc-gen/0.65/linux/hc-gen-0.65-linux.tar</a></p>
</td>
</tr>
</tbody>
</table>

## 安装Linux编译环境<a name="section8831868501"></a>

>![](public_sys-resources/icon-notice.gif) **须知：** 
>-   如果后续通过“HPM组件方式”或“HPM包管理器命令行工具方式”获取源码，不需要安装gn、ninja、LLVM、hc-gen编译工具。
>-   （推荐）如果后续通过“镜像站点方式”或“代码仓库方式”获取源码，需要安装LLVM、hc-gen编译工具。安装LLVM、hc-gen编译工具时，请确保编译工具的环境变量路径唯一。

### 安装文件打包工具<a name="section480195453419"></a>

1.  打开Linux编译服务器终端。
2.  运行如下命令，安装dosfstools。

    ```
    sudo apt-get install dosfstools
    ```

3.  运行如下命令，安装mtools。

    ```
    sudo apt-get install mtools
    ```

4.  运行如下命令，安装mtd-utils。

    ```
    sudo apt-get install mtd-utils
    ```


### 安装hc-gen<a name="section351420104218"></a>

1.  打开Linux编译服务器终端。
2.  [下载hc-gen工具](https://repo.huaweicloud.com/harmonyos/compiler/hc-gen/0.65/linux/hc-gen-0.65-linux.tar)。
3.  解压hc-gen安装包到Linux服务器\~/hc-gen路径下。

    ```
    tar -xvf hc-gen-0.65-linux.tar -C ~/
    ```

4.  设置环境变量。

    ```
    vim ~/.bashrc
    ```

    将以下命令拷贝到.bashrc文件的最后一行，保存并退出。

    ```
    export PATH=~/hc-gen:$PATH
    ```

5.  生效环境变量。

    ```
    source ~/.bashrc
    ```


