# 子系统开发指南

-   [编译构建](编译构建.md)
    -   [编译构建概述](编译构建概述.md)
    -   [编译构建开发指导](编译构建开发指导.md)
    -   [编译构建常见问题](编译构建常见问题.md)

-   [分布式远程启动](分布式远程启动.md)
-   [图形图像](图形图像.md)
    -   [图形图像概述](图形图像概述.md)
    -   [容器类组件开发指导](容器类组件开发指导.md)
    -   [布局容器类组件开发指导](布局容器类组件开发指导.md)
    -   [普通组件开发指导](普通组件开发指导.md)
    -   [动画开发指导](动画开发指导.md)

-   [媒体](媒体.md)
    -   [相机](相机.md)
        -   [相机开发概述](相机开发概述.md)
        -   [拍照开发指导](拍照开发指导.md)
        -   [录像开发指导](录像开发指导.md)
        -   [预览开发指导](预览开发指导.md)

    -   [音视频](音视频.md)
        -   [音视频开发概述](音视频开发概述.md)
        -   [音视频播放开发指导](音视频播放开发指导.md)
        -   [音视频录制开发指导](音视频录制开发指导.md)

-   [公共基础](公共基础.md)
    -   [公共基础库概述](公共基础库概述.md)
    -   [公共基础库开发指导](公共基础库开发指导.md)
    -   [公共基础库常见问题](公共基础库常见问题.md)

-   [AI框架](AI框架.md)
    -   [AI引擎框架开发指南](AI引擎框架开发指南.md)
    -   [搭建环境](搭建环境.md)
    -   [技术规范](技术规范.md)
        -   [代码管理规范](代码管理规范.md)
        -   [命名规范](命名规范.md)
        -   [接口开发规范](接口开发规范.md)

    -   [开发指导](开发指导.md)
        -   [SDK开发过程](SDK开发过程.md)
        -   [插件的开发过程](插件的开发过程.md)
        -   [配置文件的开发过程](配置文件的开发过程.md)

    -   [开发示例](开发示例.md)
        -   [唤醒词识别SDK的开发示例](唤醒词识别SDK的开发示例.md)
        -   [唤醒词识别插件的开发示例](唤醒词识别插件的开发示例.md)
        -   [唤醒词识别配置文件的开发示例](唤醒词识别配置文件的开发示例.md)

-   [Sensor服务](Sensor服务.md)
    -   [Sensor服务子系概述](Sensor服务子系概述.md)
    -   [Sensor服务子系使用指导](Sensor服务子系使用指导.md)
    -   [Sensor服务子系使用实例](Sensor服务子系使用实例.md)

-   [用户程序框架](用户程序框架.md)
    -   [概述](概述.md)
    -   [搭建环境](搭建环境-0.md)
    -   [开发指导](开发指导-1.md)
    -   [开发实例](开发实例.md)

-   [OTA升级](OTA升级.md)
-   [安全](安全.md)
    -   [概述](概述-2.md)
    -   [应用验签开发指导](应用验签开发指导.md)
    -   [应用权限管理开发指导](应用权限管理开发指导.md)
    -   [IPC通信鉴权开发指导](IPC通信鉴权开发指导.md)
    -   [可信设备群组管理开发指导](可信设备群组管理开发指导.md)
    -   [参考](参考.md)

-   [启动恢复](启动恢复.md)
    -   [启动恢复子系统概述](启动恢复子系统概述.md)
    -   [init启动引导组件](init启动引导组件.md)
    -   [appspawn应用孵化组件](appspawn应用孵化组件.md)
    -   [bootstrap服务启动组件](bootstrap服务启动组件.md)
    -   [syspara系统属性组件](syspara系统属性组件.md)
    -   [常见问题](常见问题.md)
    -   [参考](参考-3.md)

-   [测试](测试.md)
-   [DFX](DFX.md)
    -   [DFX概述](DFX概述.md)
    -   [Hilog\_lite开发指导](Hilog_lite开发指导.md)

-   [XTS认证子系统开发指南](XTS认证子系统开发指南.md)

